package jp.go.aist.rtm.logview.preferences;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import jp.go.aist.rtm.logview.LogviewPlugin;

public class PreferenceManager {
	private static PreferenceManager __instance = new PreferenceManager();

	/**
	 * RXgN^
	 * 
	 * @return VOg
	 */
	public static PreferenceManager getInstance() {
		return __instance;
	}

	/**
	 * ftHg`掞Ԏ
	 */
	public static final int defaultRedrawPeriod = 200;

	/**
	 * RtBM[VEt@C̃L[
	 */
	public static final String CONFIGURATION_FILE = PreferenceManager.class
			.getName()
			+ "CONFIGURATION_FILE";

	/**
	 * `掞Ԏ̃L[
	 */
	public static final String REDRAW_RERIOD = PreferenceManager.class
			.getName()
			+ "REDRAW_PERIOD";

	protected PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(
			this);

	/**
	 * RtBM[VEt@C擾
	 * 
	 * @param key
	 *            L[
	 * @return RtBM[VEt@C
	 */
	public String getConfigurationFile(String key) {
		LogviewPlugin.getDefault().getPreferenceStore().setDefault(key, "");

		String result = LogviewPlugin.getDefault().getPreferenceStore().getString(key);
		if (result.equals("")) { // defaultvalue
			result = "";
		}

		return result;
	}

	/**
	 * `掞Ԏݒ肷
	 * 
	 * @param key
	 *            L[
	 * @param configFile
	 *            `掞Ԏ
	 */
	public void setRedrawPeriod(String key, int interval) {
		int oldPeriod = getRedrawPeriod(key);

		LogviewPlugin.getDefault().getPreferenceStore().setValue(key, interval);

		propertyChangeSupport.firePropertyChange(key, oldPeriod, interval);
	}

	/**
	 * `掞Ԏ擾
	 * 
	 * @param key
	 *            L[
	 * @return `掞Ԏ
	 */
	public int getRedrawPeriod(String key) {
		LogviewPlugin.getDefault().getPreferenceStore().setDefault(key, "");

		int result = LogviewPlugin.getDefault().getPreferenceStore().getInt(key);
		if (result == -1) { // defaultvalue
			result = defaultRedrawPeriod;
		}

		return result;
	}

	/**
	 * RtBM[VEt@Cݒ肷
	 * 
	 * @param key
	 *            L[
	 * @param configFile
	 *            RtBM[VEt@C
	 */
	public void setConfiguratiolFile(String key, String configFile) {
		String oldConfigFile = getConfigurationFile(key);

		LogviewPlugin.getDefault().getPreferenceStore().setValue(key, configFile);

		propertyChangeSupport.firePropertyChange(key, oldConfigFile, configFile);
	}

	/**
	 * @see PropertyChangeSupport#addPropertyChangeListener(java.beans.PropertyChangeListener)
	 */
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(listener);
	}

	/**
	 * @see PropertyChangeSupport#removePropertyChangeListener(java.beans.PropertyChangeListener)
	 */
	public void removePropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(listener);
	}
}
